org.springframework.data.repository.config

## Class DefaultRepositoryConfiguration<T extends RepositoryConfigurationSource>

- java.lang.Object
- - org.springframework.data.repository.config.DefaultRepositoryConfiguration<T>

All Implemented Interfaces:
  RepositoryConfiguration<T>

    public class DefaultRepositoryConfiguration<T extends RepositoryConfigurationSource>
    extends Object
    implements RepositoryConfiguration<T>

Default implementation of `RepositoryConfiguration`.

Author:
  Oliver Gierke, Jens Schauder, Mark Paluch

### Field Summary

Fields
`static QueryLookupStrategy.Key` `DEFAULT_QUERY_LOOKUP_STRATEGY`
`static String` `DEFAULT_REPOSITORY_IMPLEMENTATION_POSTFIX`

### Constructor Summary

Constructors
Constructor and Description
`DefaultRepositoryConfiguration(T configurationSource, BeanDefinition definition, RepositoryConfigurationExtension extension)`

### Method Summary

All Methods Instance Methods Concrete Methods
`Streamable<String>` `getBasePackages()` Returns the base packages that the repository was scanned under.
`String` `getBeanId()`
`RepositoryConfigurationSource` `getConfigSource()`
`T` `getConfigurationSource()` Returns the `RepositoryConfigurationSource` that backs the `RepositoryConfiguration`.
`Streamable<TypeFilter>` `getExcludeFilters()` Returns the `TypeFilter`s to be used to exclude packages from repository scanning.
`Streamable<String>` `getImplementationBasePackages()` Returns the base packages to scan for repository implementations.
`String` `getImplementationBeanName()`
`String` `getImplementationClassName()`
`Optional<String>` `getNamedQueriesLocation()` Returns the location of the file containing Spring Data named queries.
`Object` `getQueryLookupStrategyKey()` Returns the key to resolve a `QueryLookupStrategy` from eventually.
`Optional<String>` `getRepositoryBaseClassName()` Returns the name of the repository base class to be used or null if the store specific defaults shall be applied.
`String` `getRepositoryFactoryBeanClassName()` Returns the name of the repository factory bean class to be used.
`String` `getRepositoryInterface()` Returns the interface name of the repository.
`String` `getResourceDescription()` Returns a human readable description of the repository interface declaration for error reporting purposes.
`Object` `getSource()` Returns the source of the `RepositoryConfiguration`.
`boolean` `isLazyInit()` Returns whether to initialize the repository proxy lazily.
`boolean` `isPrimary()` Returns whether the repository is the primary one for its type.
`ImplementationDetectionConfiguration` `toImplementationDetectionConfiguration(MetadataReaderFactory factory)` Returns the `ImplementationDetectionConfiguration` to be used for this repository.
`ImplementationLookupConfiguration` `toLookupConfiguration(MetadataReaderFactory factory)` Returns the `ImplementationLookupConfiguration` for the given `MetadataReaderFactory`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_REPOSITORY_IMPLEMENTATION_POSTFIX

    public static final String DEFAULT_REPOSITORY_IMPLEMENTATION_POSTFIX

See Also:
  Constant Field Values

#### DEFAULT_QUERY_LOOKUP_STRATEGY

    public static final QueryLookupStrategy.Key DEFAULT_QUERY_LOOKUP_STRATEGY

### Constructor Detail

#### DefaultRepositoryConfiguration

    public DefaultRepositoryConfiguration(T configurationSource,
                                          BeanDefinition definition,
                                          RepositoryConfigurationExtension extension)

### Method Detail

#### getBeanId

    public String getBeanId()

#### getQueryLookupStrategyKey

    public Object getQueryLookupStrategyKey()

Description copied from interface: `RepositoryConfiguration`
Returns the key to resolve a `QueryLookupStrategy` from eventually.

Specified by:
  `getQueryLookupStrategyKey` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:
See Also:
  `QueryLookupStrategy.Key`

#### getBasePackages

    public Streamable<String> getBasePackages()

Description copied from interface: `RepositoryConfiguration`
Returns the base packages that the repository was scanned under.

Specified by:
  `getBasePackages` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### getImplementationBasePackages

    public Streamable<String> getImplementationBasePackages()

Description copied from interface: `RepositoryConfiguration`
Returns the base packages to scan for repository implementations.

Specified by:
  `getImplementationBasePackages` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### getRepositoryInterface

    public String getRepositoryInterface()

Description copied from interface: `RepositoryConfiguration`
Returns the interface name of the repository.

Specified by:
  `getRepositoryInterface` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### getConfigSource

    public RepositoryConfigurationSource getConfigSource()

#### getNamedQueriesLocation

    public Optional<String> getNamedQueriesLocation()

Description copied from interface: `RepositoryConfiguration`
Returns the location of the file containing Spring Data named queries.

Specified by:
  `getNamedQueriesLocation` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### getImplementationClassName

    public String getImplementationClassName()

#### getImplementationBeanName

    public String getImplementationBeanName()

#### getSource

    @Nullable
    public Object getSource()

Description copied from interface: `RepositoryConfiguration`
Returns the source of the `RepositoryConfiguration`.

Specified by:
  `getSource` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### getConfigurationSource

    public T getConfigurationSource()

Description copied from interface: `RepositoryConfiguration`
Returns the `RepositoryConfigurationSource` that backs the `RepositoryConfiguration`.

Specified by:
  `getConfigurationSource` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### getRepositoryBaseClassName

    public Optional<String> getRepositoryBaseClassName()

Description copied from interface: `RepositoryConfiguration`
Returns the name of the repository base class to be used or null if the store specific defaults shall be applied.

Specified by:
  `getRepositoryBaseClassName` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### getRepositoryFactoryBeanClassName

    public String getRepositoryFactoryBeanClassName()

Description copied from interface: `RepositoryConfiguration`
Returns the name of the repository factory bean class to be used.

Specified by:
  `getRepositoryFactoryBeanClassName` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### isLazyInit

    public boolean isLazyInit()

Description copied from interface: `RepositoryConfiguration`
Returns whether to initialize the repository proxy lazily.

Specified by:
  `isLazyInit` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### isPrimary

    public boolean isPrimary()

Description copied from interface: `RepositoryConfiguration`
Returns whether the repository is the primary one for its type.

Specified by:
  `isPrimary` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:
  true whether the repository is the primary one for its type.

#### getExcludeFilters

    public Streamable<TypeFilter> getExcludeFilters()

Description copied from interface: `RepositoryConfiguration`
Returns the `TypeFilter`s to be used to exclude packages from repository scanning.

Specified by:
  `getExcludeFilters` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:

#### toImplementationDetectionConfiguration

    public ImplementationDetectionConfiguration toImplementationDetectionConfiguration(MetadataReaderFactory factory)

Description copied from interface: `RepositoryConfiguration`
Returns the `ImplementationDetectionConfiguration` to be used for this repository.

Specified by:
  `toImplementationDetectionConfiguration` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Parameters:
  `factory` - must not be null.
Returns:
  will never be null.

#### toLookupConfiguration

    public ImplementationLookupConfiguration toLookupConfiguration(MetadataReaderFactory factory)

Description copied from interface: `RepositoryConfiguration`
Returns the `ImplementationLookupConfiguration` for the given `MetadataReaderFactory`.

Specified by:
  `toLookupConfiguration` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Parameters:
  `factory` - must not be null.
Returns:
  will never be null.

#### getResourceDescription

    @NonNull
    public String getResourceDescription()

Description copied from interface: `RepositoryConfiguration`
Returns a human readable description of the repository interface declaration for error reporting purposes.

Specified by:
  `getResourceDescription` in interface `RepositoryConfiguration<T extends RepositoryConfigurationSource>`
Returns:
  can be null.